
#ifndef __BLIQ_STORAGE_H__
#define __BLIQ_STORAGE_H__

/* UUID of the trusted application */
#define TA_BLIQ_STORAGE_UUID \
		{ 0x0651d840, 0xa91b, 0x4b3f, \
			{ 0xa2, 0x22, 0xb6, 0x8c, 0xd1, 0x95, 0x23, 0x1c } }

/*
 * TA_BLIQ_STORAGE_CMD_CREATE_KEY - Create RSA key and store it 
 * in encrypted form (AES pin) inside secure storage file
 * param[0] (memref) ID used the identify RSA key
 * param[1] unused
 * param[2] unused
 * param[3] unused
 */
#define TA_BLIQ_STORAGE_CMD_CREATE_KEY			1

/*
 * TA_BLIQ_STORAGE_CMD_CHECK_KEY - Check if tagget RSA key pair 
 * exists and is accessinbel 
 * param[0] (memref) ID used the identify RSA key
 * param[1] unused
 * param[2] unused
 * param[3] unused
 */
#define TA_BLIQ_STORAGE_CMD_CHECK_KEY			2

/*
 * TA_BLIQ_STORAGE_CMD_DELETE - Delete tagget RSA key pair
 * param[0] (memref) ID used the identify the persistent object
 * param[1] unused
 * param[2] unused
 * param[3] unused
 */
#define TA_BLIQ_STORAGE_CMD_DELETE_KEY			3

/*
 * TA_BLIQ_STORAGE_CMD_ENCRYPT - Encrypt arbitrary string 
 * with protected RSA KeyPair from secure storage
 * param[0] (memref) ID used the identify RSA key
 * param[1] (memref) plain data to encrypt
 * param[2] (memref) encrypted data
 * param[3] unused
 */
#define TA_BLIQ_STORAGE_CMD_ENCRYPT				4

/*
 * TA_BLIQ_STORAGE_CMD_DECRYPT - Decrypt previosly encrypted string 
 * with protected RSA KeyPair from secure storage
 * param[0] (memref) ID used the identify RSA key
 * param[1] (memref) encrypted data
 * param[2] (memref) decrypted data
 * param[3] unused
 */
#define TA_BLIQ_STORAGE_CMD_DECRYPT				5

#endif /* __BLIQ_STORAGE_H__ */
